---
title: Docs - Introduction
layout: docs
tags: ['docs','introduction']
---
# Introduction

>Durandal is small JavaScript framework designed to make building Single Page Applications (SPAs) simple and elegant. We didn't try to re-invent the wheel. Durandal is built on libs you know and love like jQuery, Knockout and RequireJS. There's little to learn and building apps feels comfortable and familiar.

### Architecture

Durandal has strong support for MVC, MVP and MVVM. No matter what front end architecture paradigm you prefer, Durandal is there to back you up. With RequireJS as our base and a thin layer of conventions, we can provide amazing productivity while helping you to maintain SOLID coding practices. Pair that with out-of-the-box support for rich UI composition, modal dialogs, eventing/messaging, widgets, transitions, routing and more....and there's no doubt you'll be able to build whatever apps you can imagine; the apps of today and of tomorrow. 

Building an Android phone app? An enterprise LOB targeted at Windows? or a web gaming platform? No matter how large or small the app, it's effortless with Durandal....and we give you the tools to develop on any platform, for any platform. Use it in the browser for web deploy, with PhoneGap for phone and tablet deploy or with AppJS for PC/Mac/Linux desktop deploy. One code base; many platforms. 

Want to use a .NET backend? a NodeJS Express server? or call 3rd party web APIs? Durandal works with any backend. Use our http module, jQuery's ajax helpers or any 3rd party data layer you please.

### Features

* Clean MV* Architecture
* JS & HTML Modularity
* Simple App Lifecycle
* Eventing, Modals, Message Boxes, etc.
* Navigation & Screen State Management
* Consistent Async Programming w/ Promises
* App Bundling and Optimization
* Use any Backend Technology
* Built on top of jQuery, Knockout & RequireJS
* Integrates with popular CSS libraries such as Bootstrap
* Make Your Own Templatable and Bindable Widgets 

### Browser Support

* IE 6+
* Firefox 2+
* Safari 3.2+
* Chrome 3+
* Opera 10+

### Dependencies

* jQuery >= 1.6.0
* Knockout >= 2.2.1
* RequireJS >= 2.0.0